#include "connect-the-dots.h"

/**
 * Usage:
 *   ./shuf
 * Conditions:
 *   - Correct test in stdin
 * Effects:
 *   - Shuffles the test
 *   - Prints new test in stdout
 */
int main(int argc, char *argv[]) {
  registerGen(argc, argv, 1);

  const auto input_test = ctd::test::read(std::cin);

  ctd::test test = input_test;
  shuffle(test.points.begin(), test.points.end());

  test.print(std::cout);
}
