#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <array>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) {fprintf(stderr, __VA_ARGS__);fflush(stderr);}
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const int N = 100100;
int a[N][2];
int c[N][2];
int n;
int L;

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	scanf("%d%d", &L, &n);
	a[0][0] = a[0][1] = 0;
	a[n][0] = a[n][1] = L;
	int x, y;
	scanf("%d", &x);
	for (int i = 1; i < n; i++) {
		scanf("%d", &y);
		a[i][0] = x;
		a[i][1] = y;
		x = y;
	}

	int A, B;
	int l, r;
	l = 0, r = L + 1;
	while(r - l > 1) {
		ll x = (l + r) / 2;
		ll b = 0;
		bool ok = true;
		for (int i = 1; ok && i <= n; i++) {
			if (a[i][1] - i * x < b)
				ok = false;
			b = max(b, a[i][0] - i * x);
		}
		if (ok)
			l = x;
		else
			r = x;
	}
	A = l;

	l = -1, r = L;
	while(r - l > 1) {
		ll x = (l + r) / 2;
		ll b = 0;
		bool ok = true;
		for (int i = 1; ok && i <= n; i++) {
			if (a[i][0] - i * x > b)
				ok = false;
			b = min(b, a[i][1] - i * x);
		}
		if (ok)
			r = x;
		else
			l = x;
	}
	B = r;

	assert(A <= B);

	c[0][0] = 0; c[0][1] = 0;
	for (int i = 1; i <= n; i++) {
		c[i][0] = max(a[i][0], c[i - 1][0] + A);
		c[i][1] = min(a[i][1], c[i - 1][1] + B);
		assert(c[i][0] <= c[i][1]);
	}
	for (int i = n - 1; i >= 0; i--) {
		int x = c[i + 1][0];
		x = max(c[i][0], x - B);
		assert(x <= c[i][1]);
		c[i][0] = x;
	}
	for (int i = 0; i < n; i++)
		printf("%d %d\n", c[i][0], c[i + 1][0]);

	return 0;
}
