#include <bits/stdc++.h>
#define long long long int
using namespace std;

// @author: pashka

int L, n;
vector<int> a;
vector<int> x;

bool solve(int dmin, int dmax) {
    vector<int> xl(n + 1);
    vector<int> xr(n + 1);
    for (int i = 0; i < n; i++) {
        xl[i + 1] = max(xl[i] + dmin, a[i]);
        xr[i + 1] = min(xr[i] + dmax, a[i + 1]);
        if (xr[i + 1] < xl[i + 1]) return false;
    }
    if (xr[n] != L) return false;
    x[n] = L;
    for (int i = n - 1; i > 0; i--) {
        x[i] = max(x[i + 1] - dmax, xl[i]);
    }
    return true;
}

int main() {
    ios::sync_with_stdio(false);

    cin >> L >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    a.push_back(L);
    x.resize(n + 1);

    int dmax;
    {// min max
        int l = 0;
        int r = L + 1;
        while (r > l + 1) {
            int m = (l + r) / 2;
            if (solve(0, m)) {
                r = m;
            } else {
                l = m;
            }
        }
        dmax = r;
    }
    int dmin;
    {// max min
        int l = 0;
        int r = L + 1;
        while (r > l + 1) {
            int m = (l + r) / 2;
            if (solve(m, L)) {
                l = m;
            } else {
                r = m;
            }
        }
        dmin = l;
    }
    if (!solve(dmin, dmax)) {
        assert(false);
    }
    for (int i = 0; i < n; i++) {
        cout << x[i] << " " << x[i + 1] << "\n";
    }

    return 0;
}