#include <bits/stdc++.h>

#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)

using namespace std;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pii> vpi;
typedef vector<vi> vvi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef pair<i64, i64> pi64;
typedef double ld;

template<class T> bool uin(T &a, T b) { return a > b ? (a = b, true) : false; }
template<class T> bool uax(T &a, T b) { return a < b ? (a = b, true) : false; }

const int maxn = 2600;
const i64 P = 998244353;

void add(i64 &x, i64 y) {
    x += y;
    x %= P;
}

i64 cnk[maxn][maxn];
i64 inv[maxn];

i64 deg(i64 x, i64 d) {
    d %= P - 1;
    if (d < 0) d += P - 1;
    i64 y = 1;
    while (d) {
        if (d & 1) (y *= x) %= P;
        d /= 2;
        (x *= x) %= P;
    }
    return y;
}

i64 get_cnk(int n, int k) {
    if (k == 0 || k == n) return 1;
    if (k < 0 || k > n) return 0;
    return cnk[n][k];
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(10);
    cout << fixed;
#ifdef LOCAL_DEFINE
    freopen("input.txt", "rt", stdin);
#endif

    cnk[0][0] = 1;
    forn(i, maxn - 1) forn(j, i + 1) forn(k, 2) add(cnk[i + 1][j + k], cnk[i][j]);
    for1(i, maxn - 1) inv[i] = deg(i, -1);
    
    int T;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        int px;
        cin >> px;
        vi cnt = {1};
        for1(i, n - 1) {
            int x;
            cin >> x;
            if (x == px) ++cnt.back();
            else cnt.pb(1);
            px = x;
        }

        int K = cnt.size();
        if (cnt.back() == 1) {
            cnt.pop_back();
            --K;
        } else {
            cout << 0 << '\n';
            continue;
        }

/*        if (n == 2) {
            cout << 1 << '\n';
            continue;
        }*/

        int cl = 0;
        n = n / 2 - 1;
        vi64 dp(n + 1);
        i64 v0 = 1;
        int s = 0;
        forn(p, K) {
            int x = cnt[p];
//            cerr << p << ": " << x << ' ' << v0 << ' ' << s << '\n';
            vi64 ndp(n + 1);
            forn(i, n + 1) {
                if (!dp[i]) continue;
                int j = s - 2 * i - 1, sp = (n - i) - j;
//                cerr << p << ' ' << i << ' ' << dp[i] << ' ' << (dp[i] * j % P * inv[n - i]) % P << '\n';
//                cerr << j << ' ' << sp << '\n';
//                assert(j >= 0 && sp >= 0);
//                if (sp < 0 || j < 0) continue;
                i64 R = j * inv[n - i] % P;
                if (j) add(ndp[i + 1], dp[i] * R % P * cnk[sp][x - 1]);
                add(ndp[i], dp[i] * cnk[sp][x]);
            }
            if (s <= n) {
                add(ndp[0], v0 * cnk[n - s][x - 1]);
                (v0 *= cnk[n - s][x]) %= P;
            } else v0 = 0;
            s += x;
            dp.swap(ndp);
        }

        cout << dp[n] << '\n';
    }

#ifdef LOCAL_DEFINE
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}
