#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {
	registerValidation(argc, argv);
	validator.testset();
	int const MAX_N = 200;
	int const MAX_C = 1'000'000'000;
	int n = inf.readInt(1, MAX_N, "n");
	inf.readEoln();
	vector < vector <int> > c(n, vector <int> (n));
	for (int i = 0; i < n; i++) {
		c[i] = inf.readInts(n, 0, MAX_C, "c");
		inf.readEoln();
	}
	inf.readEof();
	for (int i = 0; i < n; i++) {
		ensuref(c[i][i] == 0, "Bad number c[%d][%d] != 0", i, i);
		for (int j = 0; j < i; j++) {
			ensuref(c[i][j] == c[j][i], "Bad number c[%d][%d] != c[%d][%d]", i, j, j, i);
		}
	}
}
