fun main() {
	val n = readInt()
	val c = List(n) { readInts() }

	val cumul = List(n + 1) { LongArray(n + 1) }
	for (i in 0 until n) for (j in 0 until n) {
		cumul[i + 1][j + 1] = cumul[i][j + 1] + cumul[i + 1][j] - cumul[i][j] + c[i][j]
	}
	fun cumul(iFrom: Int, iTo: Int, jFrom: Int, jTo: Int) =
		cumul[iTo][jTo] - cumul[iFrom][jTo] - cumul[iTo][jFrom] + cumul[iFrom][jFrom]
	fun withOther(iFrom: Int, iTo: Int) =
		cumul(0, iFrom, iFrom, iTo) + cumul(iTo, n, iFrom, iTo)

	val a = List(n + 1) { LongArray(n + 1) }
	val how = List(n + 1) { IntArray(n + 1) }
	for (len in 1..n) {
		for (i in 0..n - len) {
			val j = i + len
			val best = (i until j).associateWith { k ->
				a[i][k] + withOther(i, k) + a[k + 1][j] + withOther(k + 1, j)
			}.minByOrNull { it.value }!!
			a[i][j] = best.value
			how[i][j] = best.key
		}
	}

	fun tree(i: Int, j: Int, p: Int): List<Int> {
		if (i == j) return listOf()
		val k = how[i][j]
		return tree(i, k, k) + p + tree(k + 1, j, k)
	}
	println(tree(0, n, -1).map { it + 1 }.joinToString(" "))
}

private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }
