#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(2, 200'000, "n");
    inf.readSpace();

    int m = inf.readInt(0, 200'000, "m");
    inf.readSpace();

    inf.readInt(1, n, "s");
    inf.readEoln();

    set<pair<int,int>> edges;
    forn(i, m) {
        int u_i = inf.readInt(1, n, "u_i");
        inf.readSpace();
        int v_i = inf.readInt(1, n, "v_i");
        inf.readEoln();
        ensuref(u_i != v_i, "u_i != v_i");
        edges.insert(make_pair(u_i, v_i));
    }

    ensuref(edges.size() == m, "duplicated edges are not allowed");
    inf.readEof();
}
