#pragma GCC optimize("Ofast", "unroll-loops", "no-stack-protector")
 
#include <bits/stdc++.h>
using namespace std;
 
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a).size()
 
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using uint = unsigned int;
using ull = unsigned long long;
 
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
default_random_engine generator;
 
void solve();
 
int task;
 
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);  
#endif 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(10) << fixed;
    cerr << setprecision(10) << fixed;  
 
    int tests = 1;
    // cin >> tests;
 
    for (int test = 1; test <= tests; ++test) {
        // cout << "Case #" << test << ": ";
        solve();
    }
 
#ifdef LOCAL
    cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << endl;
#endif
}
 
// ----------------------------------------------------------------- 

const int MAXN = 200200;

vector<int> g[MAXN];
int prv[MAXN];
int used[MAXN];

int a, b;

bool dfs(int v, int c, int p = -1) {
    used[v] = c;
    prv[v] = p;

    for (int u : g[v]) {
        if (used[u]) {
            if (used[u] != c) {
                a = u;
                b = v;
                return true;
            }
        } else if (dfs(u, c, v)) {
            return true;
        }
    }
    return false;
}


void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    --t;

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        if (v != t) {
            g[u].push_back(v);
        }
    }

    for (int u : g[t]) {
        if (dfs(u, u + 1, t)) {
            cout << "Possible\n";
            array<vector<int>, 2> paths;
            paths[0].push_back(a);
            paths[1].push_back(b);
            for (int k = 0; k < 2; ++k) {
                while (paths[k].back() != t) {
                    paths[k].push_back(prv[paths[k].back()]);
                }
                reverse(all(paths[k]));
            }
            paths[1].push_back(a);

            for (int k = 0; k < 2; ++k) {
                cout << sz(paths[k]) << "\n";
                for (int u : paths[k]) {
                    cout << u + 1 << " ";
                }
                cout << "\n";
            }
            return;
        }
    }

    cout << "Impossible\n"; 

}
