#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)

const int N = 100;

bool g[N][N];
bool visited[N];
int n, s;
vector<int> path;
vector<vector<int>> paths;

void go(int u) {
    visited[u] = true;
    path.push_back(u);
    if (path.size() > 1)
        paths.push_back(path);
    forn(v, n)
        if (g[u][v] && !visited[v])
            go(v);
    visited[u] = false;
    path.pop_back();
}

void print(vector<int> p) {
    cout << p.size() << endl;
    forn(i, p.size()) {
        if (i > 0)
            cout << " ";
        cout << p[i] + 1;
    }
    cout << endl;
}

int main() {
    int m;
    cin >> n >> m >> s;
    while (n > N);

    forn(i, m) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u][v] = true;
    }

    go(s - 1);
    assert(paths.size() == set<vector<int>>(paths.begin(), paths.end()).size());
    forn(i, paths.size())
        forn(j, i)
            if (paths[i].back() == paths[j].back()) {
                set<int> internals;
                for (int y = 1; y < int(paths[i].size()) - 1; y++)
                    internals.insert(paths[i][y]);
                bool fail = false;
                for (int y = 1; y < int(paths[j].size()) - 1; y++)
                    if (internals.count(paths[j][y])) {
                        fail = true;
                        break;
                    }
                if (!fail) {
                    cout << "Possible" << endl;
                    print(paths[i]);
                    print(paths[j]);
                    return 0;
                }
            }
    cout << "Impossible" << endl;
}
