#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <array>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) {fprintf(stderr, __VA_ARGS__);fflush(stderr);}
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const int N = 60060;
int n;
char s[N];
int ANS;
int a[N];

void solve(int zzz, int b, int minLen) {
	minLen -= zzz;
	char* t = s + zzz;
	int m = n - zzz;
	memset(a, 0, sizeof(a));
	for (int r = b; r <= m; r += b) {
		int l = r - b;
		if (t[r - 1] == 'R') return;
		if (t[l] == 'L') return;
		bool ok = true;
		for (int i = l; i < r; i++) {
			int x = i;
			if (t[i] == 'L')
				x--;
			else if (t[i] == 'R')
				x++;
			else if (t[i] == 'U')
				x -= b;
			else {
				ok = false;
				x += b;
			}
			if (x < 0) return;
			if (a[x]) return;
			a[x] = 1;
		}
		if (ok && r > minLen) ANS++;
	}
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	scanf("%s", s);
	n = strlen(s);
	int xxx = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == 'R' || s[i] == 'D')
			xxx++;
		else
			xxx--;
	}
	if (xxx > 0) {
		reverse(s, s + n);
		for (int i = 0; i < n; i++) {
			if (s[i] == 'U' || s[i] == 'D') {
				s[i] ^= 'U' ^ 'D';
			} else {
				s[i] ^= 'L' ^ 'R';
			}
		}
	}
	for (int l = 0; l < n; l++) {
		if (s[l] != 'R' && s[l] != 'D') continue;
		int r = l;
		while(r + 2 <= n && s[r] == 'R' && s[r + 1] == 'L') {
			r += 2;
			ANS++;
		}
		if (r + 2 > n) continue;
		if (s[r] == 'R') {
			int q = r + 1;
			while(q < n && s[q] != 'U') q++;
			if (q >= n) continue;
			solve(l, q - r, r);
		} else if (s[r] == 'D') {
			int p = r + 1;
			while(p < n && s[p] == 'L') p++;
			if (p == n) continue;
			int q = p;
			while(q < n && s[q] != 'U') q++;
			if (q >= n) continue;
			solve(l, q - p + 1, r);
		} else continue;
	}
	printf("%d\n", ANS);

	return 0;
}
