import java.util.Scanner;

public class admissible_iz_bm {
    public static long solve(char[] s) {
        int k = s.length;

        char[] dc = "ULDR".toCharArray();
        int[] a = new int[k];
        for (int i = 0; i < a.length; i++) {
            while (dc[a[i]] != s[i]) {
                a[i] += 1;
            }
        }

        BitSet[] b = new BitSet[4];
        for (int i = 0; i < b.length; i++) {
            b[i] = new BitSet(k);
        }
        for (int i = 0; i < k; i++) {
            b[a[i]].setBit(i);
        }
        BitSet[] bn = new BitSet[b.length];
        for (int i = 0; i < bn.length; i++) {
            bn[i] = b[i].not();
        }

        BitSet[] good = new BitSet[k / 2];
        for (int i = 0; i < good.length; i++) {
            good[i] = new BitSet(k);
        }
        BitSet[] cb = new BitSet[b.length];
        for (int i = 0; i < cb.length; i++) {
            cb[i] = b[i].makeCopy();
        }
        cb[1] = cb[1].shiftRight(1, false);
        cb[3] = cb[3].shiftLeft(1, false);
        cb[3].unsetBit(k);
        for (int m = 1; m * 2 <= k; m++) {
            cb[0] = cb[0].shiftRight(1, false);
            cb[2] = cb[2].shiftLeft(1, false);
            cb[2].unsetBit(k);

            BitSet neibUL = cb[2].or(cb[3]);
            BitSet neibDR = cb[0].or(cb[1]);
            BitSet neibUR = cb[1].or(cb[2]);
            BitSet neibLD = cb[0].or(cb[3]);

            BitSet neibAny = neibUL.or(neibDR);
            BitSet neibULD = neibUL.or(cb[0]);
            BitSet neibULR = neibUL.or(cb[1]);
            BitSet neibUDR = neibDR.or(cb[2]);
            BitSet neibLDR = neibDR.or(cb[3]);

            BitSet good_up_start = neibLDR.and(bn[0], true).allNextMones(m).and(neibDR, true).and(neibLD.shiftRight(m - 1, true), false);
            BitSet good_mid_start = neibAny.allNextMones(m).and(neibUDR, true).and(neibULD.shiftRight(m - 1, true), true).and(bn[1], true).and(bn[3].shiftRight((m - 1), true), false);
            BitSet good_bot_start = neibULR.and(bn[2], true).allNextMones(m).and(neibUR, true).and(neibUL.shiftRight(m - 1, true), false);

            BitSet cur = good_up_start.and(good_mid_start, false);
            for (int n = 2; m * n <= k; n++) {
                int shift = (n - 1) * m;
                cur.andEq(good_mid_start.shiftRight(shift, true));
                if (n * m % 2 == 0) {
                    good[m * n / 2 - 1].orEq(cur.and(good_bot_start.shiftRight(shift, true), true));
                }
            }
        }

        long ans = 0;
        for (BitSet bt : good) {
            ans += bt.countOnes();
        }
        for (int i = 0; i + 1 < k; i++) {
            if (s[i] == 'R' && s[i + 1] == 'L') {
                ans += 1;
            }
        }

        return ans;
    }

    static class ArrayPool {
        long[][] arrays;
        int it = 0;

        ArrayPool(int size) {
            arrays = new long[size][];
        }

        long[] createArray(int len, boolean tmp) {
            if (!tmp) {
                return new long[len];
            }
            it = (it + 1) % arrays.length;
            if (arrays[it] == null) {
                arrays[it] = new long[len];
            }
            return arrays[it];
        }
    }

    static ArrayPool arrayPool = new ArrayPool(30);

    static class BitSet {
        long[] a;

        BitSet(int numBits) {
            a = new long[(numBits + 63) / 64 + 2];
        }

        BitSet(long[] a) {
            this.a = a;
        }

        void setBit(int idx) {
            a[idx >> 6] |= 1L << (idx & 63);
        }
        void unsetBit(int idx) { a[idx >> 6] &= ~(1L << (idx & 63)); }

        boolean isSet(int idx) {
            return (a[idx >> 6] & (1L << (idx & 63))) != 0;
        }

        BitSet not() {
            long[] na = new long[a.length];
            for (int i = 0; i < a.length; i++) {
                na[i] = ~a[i];
            }
            return new BitSet(na);
        }

        BitSet makeCopy() {
            long[] na = arrayPool.createArray(a.length, false);
            System.arraycopy(a, 0, na, 0, a.length);
            return new BitSet(na);
        }

        BitSet shiftRight(int len, boolean tmp) {
            int full = len / 64;
            int part = len & 63;
            long[] na = arrayPool.createArray(a.length, tmp);
            for (int i = Math.max(0, a.length - full); i < a.length; i++) na[i] = 0;
            for (int i = full; i < a.length; i++) {
                na[i - full] = a[i] >>> part;
                if (part != 0 && i > full) {
                    na[i - full - 1] |= (a[i] << (64 - part));
                }
            }
            return new BitSet(na);
        }

        BitSet shiftLeft(int len, boolean tmp) {
            int full = len / 64;
            int part = len & 63;
            long[] na = arrayPool.createArray(a.length, tmp);
            for (int i = 0; i <= full; i++) na[i] = 0;
            for (int i = 0; i + full < a.length; i++) {
                na[i + full] |= a[i] << part;
                if (part != 0 && i + full + 1 < a.length) {
                    na[i + full + 1] = (a[i] >>> (64 - part));
                }
            }
            return new BitSet(na);
        }

        void andEq(BitSet another) {
            for (int i = 0; i < a.length; i++) {
                a[i] &= another.a[i];
            }
        }

        void orEq(BitSet another) {
            for (int i = 0; i < a.length; i++) {
                a[i] |= another.a[i];
            }
        }

        BitSet or(BitSet another) {
            long[] na = arrayPool.createArray(a.length, false);
            for (int i = 0; i < a.length; i++) {
                na[i] = a[i] | another.a[i];
            }
            return new BitSet(na);
        }

        BitSet and(BitSet another, boolean tmp) {
            long[] na = arrayPool.createArray(a.length, tmp);
            for (int i = 0; i < a.length; i++) {
                na[i] = a[i] & another.a[i];
            }
            return new BitSet(na);
        }

        BitSet allNextMones(int m) {
            if (m <= 128) {
                BitSet bt = makeCopy();
                int cur = 1;
                while (cur * 2 <= m) {
                    bt.andEq(bt.shiftRight(cur, true));
                    cur *= 2;
                }
                if (m - cur != 0) {
                    bt.andEq(bt.shiftRight(m - cur, true));
                }
                return bt;
            } else {
                BitSet bt = makeCopy();

                m--;
                int cnt = m / 64 - 1;
                int rem = m % 64;

                for (int i = 0; i < bt.a.length - 1; i++) {
                    if (bt.a[i] != -1) {
                        int highest_zero_pos = 63 - Long.numberOfLeadingZeros(~bt.a[i]);
                        int lowest_zero_pos = Long.numberOfTrailingZeros(bt.a[i] + 1);
                        bt.a[i] &= -(1L << highest_zero_pos);

                        int j = i - 1;
                        int iters = Math.min(cnt, i);
                        while (iters-- > 0) {
                            if (bt.a[j] != -1) {
                                bt.a[j] = 0;
                                break;
                            }
                            bt.a[j--] = 0;
                        }
                        j = Math.max(j, 0);
                        int last_affected_bit = lowest_zero_pos - rem;
                        bt.a[j] &= (1L << Math.max(0, last_affected_bit)) - 1;
                        if (last_affected_bit < 0 && j > 0) {
                            last_affected_bit += 64;
                            j--;
                            bt.a[j] &= (1L << Math.max(0, last_affected_bit)) - 1;
                        }
                    }
                }
                return bt;
            }
        }


        int countOnes() {
            int res = 0;
            for (long x : a) {
                res += Long.bitCount(x);
            }
            return res;
        }
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        System.out.println(solve(sc.nextLine().toCharArray()));
    }
}
