#include "testlib.h"

int main(int argc, char **argv) {
  registerGen(argc, argv, 1);
  int t = opt<int>("t");
  int q = opt<int>("q");
  int minn = has_opt("minn") ? opt<int>("minn") : 2;
  int maxn = has_opt("maxn") ? opt<int>("maxn") : 5;
  long long minq = has_opt("minq") ? opt<long long>("minq") : 0LL;
  long long maxq = has_opt("maxq") ? opt<long long>("maxq") : 1'000'000'000'000LL;
  int maxc = has_opt("maxc") ? opt<int>("maxc") : 100'000;

  printf("%d %d\n", t, q);
  for (int i = 0; i < t; i++) {
    int n = rnd.next(minn, maxn);
    printf("%d", n);
    for (int i = 0; i < n; i++) {
      printf(" %d", rnd.next(1, maxc));
    }
    for (int i = 0; i < n; i++) {
      printf(" %d", rnd.next(1, 1000));
    }
    printf("\n");
  }
  for (int i = 0; i < q; i++) {
    printf("%lld%c", rnd.next(minq, maxq), " \n"[i == q - 1]);
  }

}
