#include "testlib.h"

constexpr int MAXT = 50'000;
constexpr int MAXQ = 300'000;
constexpr int MAXN = 5;
constexpr int MAXC = 100'000;
constexpr int MAXP = 1000;
constexpr long long MAXB = 1'000'000'000'000LL;

int main(int argc, char **argv) {
  registerValidation(argc, argv);
  int T = inf.readInt(1, MAXT, "T");
  inf.readSpace();
  int Q = inf.readInt(1, MAXQ, "Q");
  inf.readEoln();
  int totn = 0;
  for (int i = 0; i < T; i++) {
    int n = inf.readInt(2, MAXN, "n_i");
    inf.readSpace();
    auto c = inf.readInts(n, 0, MAXC, "c");
    ensure(find_if(c.begin(), c.end(), [] (int x) { return x != 0; }) != c.end());
    inf.readSpace();
    inf.readInts(n, 1, MAXP, "p");
    inf.readEoln();
  }
  inf.readLongs(Q, 0, MAXB, "q");
  inf.readEoln();
  inf.readEof();
}
