    #include "testlib.h"
    #include <iostream>
    #include "testlib.h"

    using namespace std;

    int main(int argc, char *argv[]) {
        registerGen(argc, argv, 1);
        int l = atoi(argv[1]);
        int n = atoi(argv[2]);
        int m = atoi(argv[3]);

        vector<int> a(m, 1);
        int nn = n - m;
        while (nn--) {
            a[rnd.next(0, m - 1)]++;
        }

        double p1 = rnd.next(0.1, 1.0);
        double p2 = rnd.next(0.1, 1.0);

        double n1 = 0;
        double n2 = 0;
        for (int i = 0; i < m; i++) {
            if (i % 2 == 0) n1 += a[i]; else n2 += a[i];
        }

        double q = l / (n1 * p1 + n2 * p2);
        int l1 = max((int) (p1 * q), 1);
        int l2 = max((int) (p2 * q), 1);

        vector<int> x(n + 1);
        int k = 0;
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < a[i]; j++) {
                k++;
                x[k] = x[k - 1] + ((i % 2 == 0) ? l1 : l2);
            }
        }
        x[n] = min(x[n], l);
        for (int i = n - 1; i >= 0; i--) {
            x[i] = min(x[i], x[i + 1] - 1);
        }

        vector<int> p(n);
        for (int i = 0; i < n; i++) {
            p[i] = rnd.next(x[i], x[i + 1]);
            if (i > 0 && p[i] == p[i - 1]) p[i]++;
        }

        cout << x[n] << " " << n << "\n";
        for (int i = 0; i < n; i++) {
            cout << p[i] << " \n"[i == n - 1];
        }


    }