#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
// #define make_unique(x) sort(all(x)); x.resize(unique(all(x)) - x.begin())

using namespace std;

inline int nxt() {
	int x;
	// scanf("%d", &x);
	cin >> x;
	return x;
}

void solve() {
	int l = nxt(), n = nxt();
	vector<int> a(n);
	generate(all(a), nxt);

	vector<pair<int, int>> where_can(n + 1, {0, 0});

	auto can = [&](int from, int to) {
		pair<int, int> where = {0, 0};
		// for (int x : a) {
		for (int i = 0; i < n; ++i) {
			int x = a[i];
			auto [ll, rr] = where;
			if (rr + to < x) {
				return -1;
			} else if (ll > x) {
				return 1;
			} else {
				where = {max(x, ll + from), min(rr, x) + to};
			}
			where_can[i + 1] = where;
		}
		if (l < where.first) {
			return 1;
		} else if (l > where.second) {
			return -1;
		} else {
			return 0;
		}
	};

	[[maybe_unused]] int good_from = -1, good_to = -1;

	auto check = [&](int diff) {
		int le = 0, ri = l;
		while (ri > le + 1) {
			int m = (le + ri) / 2;
			if (int s = can(m, m + diff); s == 0) {
				good_from = m;
				good_to = m + diff;
				return true;
			} else if (s == -1) {
				le = m;
			} else {
				ri = m;
			}
		}
		return false;
	};

	int low = -1, high = l;
	while (high > low + 1) {
		int mid = (low + high) / 2;
		(check(mid) ? high : low) = mid;
	}
	// cout << high << "\n";
	assert(check(high));

	vector<int> ans(n + 1);
	ans[n] = l;
	for (int i = n - 1; i >= 0; --i) {
		int le = ans[i + 1] - good_to;
		ans[i] = max(le, where_can[i].first);
	}
	for (int i = 0; i < n; ++i) {
		cout << ans[i] << " " << ans[i + 1] << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1; // nxt();
	while (t--) {
		solve();
	}

	return 0;
}
