#include <bits/stdc++.h>

#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)

using namespace std;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pii> vpi;
typedef vector<vi> vvi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef pair<i64, i64> pi64;
typedef double ld;

template<class T> bool uin(T &a, T b) { return a > b ? (a = b, true) : false; }
template<class T> bool uax(T &a, T b) { return a < b ? (a = b, true) : false; }

const int maxn = 5100;
const i64 P = 998244353;

void add(i64 &x, i64 y) {
    x += y;
    x %= P;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(10);
    cout << fixed;
#ifdef LOCAL_DEFINE
    freopen("input.txt", "rt", stdin);
#endif

    int T;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        int px;
        cin >> px;
        vi cnt = {1};
        for1(i, n - 1) {
            int x;
            cin >> x;
            if (x == px) ++cnt.back();
            else cnt.pb(1);
            px = x;
        }

        int K = cnt.size();
        if (cnt.back() == 1) {
            cnt.pop_back();
            --K;
        } else {
            cout << 0 << '\n';
            continue;
        }

        vi pcnt(K + 1);
        forn(i, K) pcnt[i + 1] = pcnt[i] + cnt[i];
        int cl = 0;
        vi64 dp(n / 2 + 1);
        forn(i, K) {
            ford(j, n / 2) {
                if (j < 1) break;
                int sm = pcnt[i] - 2 * j - 1;
                if (sm > 0) add(dp[j + 1], dp[j] * sm);
            }
            add(dp[1], i * (i - 1) + cl);

            if (cnt[i] > 1) ++cl;
/*            cerr << cnt[i] << ": ";
            for (auto x: dp) cerr << x << ' ';
            cerr << '\n';*/
        }

        cout << dp[n / 2 - 1] << '\n';
    }

#ifdef LOCAL_DEFINE
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}
