#include "testlib.h"

constexpr int MAX_T = 1000;
constexpr int MAX_N = 1000;
constexpr int MAX_SUM_N = 1000;
constexpr int MAX_DAMAGE = 1'000'000'000;
constexpr int MAX_HEALTH = 1'000'000'000;
constexpr int MAX_A_I = 1'000'000'000;

int main(int argc, char **argv)
{
    registerValidation(argc, argv);
    int T = inf.readInt(1, MAX_T, "T");
    inf.readEoln();
    int sum_n = 0;
    for (int t = 0; t < T; t++)
    {
        setTestCase(t + 1);
        int n = inf.readInt(1, MAX_N, "n");
        sum_n += n;
        ensure(sum_n <= MAX_SUM_N);

        inf.readSpace();
        inf.readInt(1, MAX_DAMAGE, "damage");
        inf.readSpace();
        int health = inf.readInt(1, MAX_HEALTH, "health");
        inf.readEoln();

        long long sum_ai = 0;
        for (int i = 0; i < n; i++)
        {
            int ai = inf.readInt(1, MAX_A_I, "a_i");
            sum_ai += ai;
            if (i == n - 1)
            {
                inf.readEoln();
            }
            else
            {
                inf.readSpace();
            }
        }
        ensure(sum_ai <= MAX_A_I);
        ensure(sum_ai * health <= MAX_A_I);
    }

    inf.readEof();
}
