#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
// #define make_unique(x) sort(all(x)); x.resize(unique(all(x)) - x.begin())

using namespace std;

inline int nxt() {
	int x;
	// scanf("%d", &x);
	cin >> x;
	return x;
}

// #define TEST

#ifdef TEST
int g_x[2], g_y[2];
int g_n, g_m;
int rem;
#endif

int ask(int x, int y) {
#ifdef TEST
	assert(clamp(x, 0, g_n - 1) == x);
	assert(clamp(y, 0, g_m - 1) == y);
	assert(rem--);
	return abs(x - g_x[0]) + abs(y - g_y[0]) + abs(x - g_x[1]) + abs(y - g_y[1]);
#else
	cout << "SCAN " << x + 1 << " " << y + 1 << endl;
	return nxt();
#endif
}

bool dig(int x, int y) {
#ifdef TEST
	assert(clamp(x, 0, g_n - 1) == x);
	assert(clamp(y, 0, g_m - 1) == y);
	assert(rem--);
	return (x == g_x[0] && y == g_y[0]) || (x == g_x[1] && y == g_y[1]);
#else
	cout << "DIG " << x + 1 << " " << y + 1 << endl;
	return !!nxt();
#endif
}

void remax(int& x, int y) {
	x = (x > y) ? x : y;
}

void solve() {
#ifdef TEST
	int n = g_n, m = g_m;
#else
	[[maybe_unused]] int n = nxt(), m = nxt();
#endif
	int fst = ask(0, 0);
	int snd = ask(n - 1, 0);
	int sy = (fst + snd - 2 * (n - 1)) / 2;
	int sx = fst - sy;
	int d = ask(sx / 2, sy / 2);	// twice the distance from center to each

	vector<vector<char>> can(n, vector<char>(m, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			can[i][j] = abs(sx / 2 - i) + abs(sx - sx / 2 - i) + abs(sy / 2 - j) + abs(sy - sy / 2 - j) == d;
		}
	}
	int qx = -1, qy = -1;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (can[i][j]) {
				qx = i, qy = j;
				// cerr << "can " << i + 1 << " " << j + 1 << "\n";
			}
		}
	}
	// cerr << "-----\n";
	int qr = ask(qx, qy);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			can[i][j] &= abs(qx - i) + abs(sx - qx - i) + abs(qy - j) + abs(sy - qy - j) == qr;
		}
	}
	int x = -1, y = -1;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (can[i][j]) {
				x = i, y = j;
				// cerr << "can " << i + 1 << " " << j + 1 << "\n";
			}
		}
	}

	if (dig(x, y)) {
		assert(dig(sx - x, sy - y));
	} else {
		assert(dig(x, sy - y));
		assert(dig(sx - x, y));
	}
}

int main() {
	// ios_base::sync_with_stdio(false);
	// cin.tie(nullptr);

#ifdef TEST
	for (g_n = 2; g_n <= 10; ++g_n) {
		for (g_m = 2; g_m <= 10; ++g_m) {
			for (int i = 0; i < g_n * g_m; ++i) {
				for (int j = 0; j < i; ++j) {
					g_x[0] = i / g_m, g_y[0] = i % g_m;
					g_x[1] = j / g_m, g_y[1] = j % g_m;
					rem = 7;
					solve();
					cerr << g_n << " " << g_m << " " << g_x[0] << " " << g_y[0] << " " << g_x[1] << " " << g_y[1] << ": ok\n";
				}
			}
		}
	}
#else
	int t = nxt();
	while (t--) {
		solve();
	}
#endif

	return 0;
}
