private fun solve() {
	fun ask(x: Int, y: Int, op: String) = println("$op ${x + 1} ${y + 1}").let { readInt() }
	fun scan(x: Int, y: Int) = ask(x, y, "SCAN")
	fun dig(x: Int, y: Int) = ask(x, y, "DIG")

	val (_, hei) = readInts()
	val `x1+x2+y1+y2` = scan(0, 0)
	val `x1+x2-y1-y2` = scan(0, hei - 1) - 2 * (hei - 1)
	val `x1+x2` = (`x1+x2+y1+y2` + `x1+x2-y1-y2`) / 2
	val `y1+y2` = (`x1+x2+y1+y2` - `x1+x2-y1-y2`) / 2
	val `xMax-xMin+yMax-yMin` = scan(`x1+x2` / 2, `y1+y2` / 2)
	val `x1+x2+yMax-yMin` = scan(0, `y1+y2` / 2)
	val xMin = (`x1+x2+yMax-yMin` - `xMax-xMin+yMax-yMin`) / 2
	val xMax = `x1+x2` - xMin
	val `yMax-yMin` = `xMax-xMin+yMax-yMin` - (xMax - xMin)
	val yMin = (`y1+y2` - `yMax-yMin`) / 2
	val yMax = `y1+y2` - yMin
	if (dig(xMin, yMin) == 1) {
		dig(xMax, yMax)
	} else {
		dig(xMin, yMax); dig(xMax, yMin)
	}
}

fun main() {
	repeat(readInt()) { solve() }
}

private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }
