#include "testlib.h"

using namespace std;

int const MAXN = 1000;
int const MAXM = 2000;
int const MAXC = 1'000'000'000;

int main(int argc, char **argv) {
	registerValidation(argc, argv);
	int n = inf.readInt(2, MAXN, "n");
	inf.readSpace();
	int m = inf.readInt(0, MAXM, "m");
	inf.readEoln();
	int a = inf.readInt(1, n, "a");
	inf.readSpace();
	int b = inf.readInt(1, n, "b");
	ensuref(a != b, "a = b");
	inf.readEoln();
	set<pair<int, int>> edges;
	for (int i = 0; i < m; i++) {
		int v = inf.readInt(1, n, "v");
		inf.readSpace();
		int u = inf.readInt(1, n, "u");
		ensuref(v != u, "v[%d] = u[%d] = %d", i + 1, i + 1, v);
		if (v > u) swap(v, u);
		ensuref(edges.insert({v, u}).second, "Edge {%d, %d} is used twice", v, u);
		inf.readSpace();
		inf.readInt(1, MAXC, "len");
		inf.readEoln();
	}
	inf.readEof();
}
