/**
 * Niyaz Nigmatullin
 */

#include <bits/stdc++.h>

using namespace std;

struct edge {
	int from;
	int to;
	int len;
};

bool in(int i, int mask) {
	return ((mask >> i) & 1) == 1;
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(0);
	int n, m;
	cin >> n >> m;
	int va, vb;
	cin >> va >> vb;
	--va;
	--vb;
	vector<edge> edges;
	for (int i = 0; i < m; i++) {
		int v, u, len;
		cin >> v >> u >> len;
		--v;
		--u;
		edges.push_back({v, u, len});
	}
	int best = 1 << 30;
	int bestMaskA = -1;
	int bestMaskB = -1;
	for (int maskA = 1; maskA < 1 << n; maskA++) {
		if (((maskA >> va) & 1) == 0 || ((maskA >> vb) & 1) == 1) continue;
		int bSuper = ((1 << n) - 1) & ~maskA;
		for (int maskB = bSuper; maskB > 0; maskB = (maskB - 1) & bSuper) {
			if (((maskB >> vb) & 1) == 0) continue;
			int cost = 0;
			for (auto &e : edges) {
				if ((in(e.from, maskA) && in(e.to, maskA)) || (in(e.from, maskB) && in(e.to, maskB))) {
					cost += 2 * e.len;
				} else if (in(e.from, maskA | maskB) != in(e.to, maskA | maskB)) {
					cost += e.len;
				}
			}
			if (best > cost) {
				best = cost;
				bestMaskA = maskA;
				bestMaskB = maskB;
			}
		}
	}
	cout << best << endl;
	for (int i = 0; i < n; i++) {
		if (((bestMaskA >> i) & 1) == 1) {
			cout << "A";
		} else if (((bestMaskB >> i) & 1) == 1) {
			cout << "B";
		} else {
			cout << "C";
		}
	}
	cout << endl;
}
