#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>("n");
    int m = opt<int>("m");
    m = min(m, n * (n - 1));
    int s = rnd.next(1, n);
    cout << n << " " << m << " " << s << endl;

    set<pair<int, int>> edges;
    while (edges.size() < m) {
        int u = rnd.next(1, n);
        int v = rnd.next(1, n);
        if (u == v || edges.find({u, v}) != edges.end()) {
            continue;
        }
        edges.insert({u, v});
        cout << u << " " << v << endl;
    }
    return 0;
}