@OptIn(ExperimentalStdlibApi::class)
fun main() {
    val (n, m, s1) = readLine()!!.split(" ").map { it.toInt() }
    val s = s1 - 1
    val g = List(n) { ArrayList<Int>() }
    repeat(m) {
        val (u, v) = readLine()!!.split(" ").map { it.toInt() - 1 }
        g[u] += v
    }
    val f = IntArray(n)
    val p = IntArray(n) { -1 }
    data class R(val u: Int, val v: Int)
    var ord = 0
    val dfs = DeepRecursiveFunction<R, R?> rec@{ (u, prev) ->
        if (f[u] == ord) return@rec null
        if (f[u] == 0) {
            f[u] = ord
            p[u] = prev
        } else {
            return@rec R(u, prev)
        }
        for (v in g[u]) {
            callRecursive(R(v, u))?.let { return@rec it }
        }
        null
    }
    var res: R? = null
    for (v in g[s]) {
        ord++
        f[s] = ord
        res = dfs(R(v, s))
        if (res != null) break
    }
    if (res == null) {
        println("Impossible")
    } else {
        fun printPath(t: Int) {
            var u = t
            val a = ArrayList<Int>()
            while (u >= 0) {
                a += u
                u = p[u]
            }
            a.reverse()
            println(a.size)
            println(a.joinToString(" ") { (it + 1).toString() })
        }
        println("Possible")
        printPath(res.u)
        p[res.u] = res.v
        printPath(res.u)
    }

}